#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <stack>
#include <cstring>
#include <cassert>
using namespace std;
#define rep(i,a,n) for (int i=a;i<(int)(n);i++)
#define per(i,a,n) for (int i=(n)-1;i>=(int)(a);i--)
template<typename T> ostream& operator<<(ostream& _s, vector<T> _t) {rep(i, 0, _t.size()) _s << (i ? " " : "") << _t[i]; return _s;}
template<typename T> istream& operator>>(istream& _s, vector<T> &_t) {rep(i, 0, _t.size()) _s >> _t[i]; return _s;}
template<typename T, typename U> ostream& operator<<(ostream& _s, pair<T, U> _t) {_s << "(" << _t.first << "," << _t.second << ")"; return _s;}
template<typename T, typename U> istream& operator>>(istream& _s, pair<T, U> &_t) {_s >> _t.first >> _t.second; return _s;}
typedef long long ll;

const ll MOD = 1000003;

int main() {
    // ios_base::sync_with_stdio(false);
    int n;
    scanf("%d", &n);

    vector<vector<int>> g(n);
    rep(a,1,n) {
        int b;
        scanf("%d", &b);
        b--;
        g[b].push_back(a);
        g[a].push_back(b);
    }
    vector<int> dfs_ord = {0};
    vector<int> parent(n, -1);
    parent[0] = -2;
    rep(i,0,n) {
        for (int b : g[dfs_ord[i]]) {
            if (parent[b] == -1) {
                dfs_ord.push_back(b);
                parent[b] = dfs_ord[i];
            }
        }
    }

    ll res = 0;
    vector<ll> sz(n, 1);
    per(i,0,n) {
        int a = dfs_ord[i];
        for (int b : g[a]) {
            if (b != parent[a]) {
                sz[a] += sz[b];
            }
        }
        if (parent[a] != -2) {
            res = (res + sz[a] * (n - sz[a])) % MOD;
        }
    }

    printf("%lld\n", res);
}
